<?php
$GUESTBOOK_URL_PATH = ".";
$DEMO_MODE = FALSE;
$SHOW_PAGE_NUMBER_NAVIGATION = FALSE;
$NAVIGATION_MAX_PAGE_NUMBERS = 10;
$DISPLAY_TIME_ZONE = "";
$PREVIOUS_TEXT = "< Prev";
$NEXT_TEXT = "Next >";
$DISPLAY_EMAIL_FIELD = TRUE;
$DISPLAY_URL_FIELD = TRUE;
$DISPLAY_COMMENT_FIELD = TRUE;
##########
function show_entry($entry, $idx, $showCheckbox = FALSE, $showadminfields = FALSE, $elementId = NULL) 
{
global $DATE_TIME_FORMAT;
global $NAME_FIELD_NAME;
global $EMAIL_FIELD_NAME;
global $URL_FIELD_NAME;
global $COMMENTS_FIELD_NAME;
global $ENABLE_EMAIL_FIELD;
global $ENABLE_URL_FIELD;
global $ENABLE_COMMENT_FIELD;
?>
<div <?php if($elementId != NULL) 
{
echo(" id=\"" . htmlspecialchars($elementId) . "\""); 
} 
?>
>
<?php
if($showCheckbox) 
{
?>
Delete this comment? <input type="checkbox" name="id[]" value="<?php echo $entry["id"]; ?>"/>
<br/>
<b>Idnr:</b> <?php echo $entry["id"] ?>
<br/>
<?php
}
?>
<b><?php echo $NAME_FIELD_NAME ?>:</b> <?php echo $entry["name"] ?>
<br/>
<?php
global $DISPLAY_EMAIL_FIELD;
if($ENABLE_EMAIL_FIELD === TRUE && !empty($entry["email"]) && ($showadminfields || $DISPLAY_EMAIL_FIELD) ) 
{
?>
<b><?php echo $EMAIL_FIELD_NAME ?>:</b> <a href="mailto:<?php echo $entry["email"] ?>"><?php echo $entry["email"] ?></a>
<br/>
<?php
}
global $DISPLAY_URL_FIELD;
if($ENABLE_URL_FIELD === TRUE && !empty($entry["url"]) && ($showadminfields || $DISPLAY_URL_FIELD) ) 
{
?>
<b><?php echo $URL_FIELD_NAME ?>:</b> <a href="<?php echo $entry["url"] ?>" rel="nofollow" target="_blank"><?php echo $entry["url"] ?></a>
<br/>
<?php
}
global $DISPLAY_COMMENT_FIELD;
if($ENABLE_COMMENT_FIELD === TRUE && !empty($entry["comments"]) && ($showadminfields || $DISPLAY_COMMENT_FIELD) ) {
?>
<b><?php echo $COMMENTS_FIELD_NAME ?>:</b> <?php echo str_replace(array("\r\n", "\n", "\r"), "<br />", $entry["comments"]) ?>
<br/>
<?php
}
global $DEMO_MODE;
if($showadminfields) 
{
?>
<b>Idip:</b> <a href="http://whois-search.com/whois/<?php echo(($DEMO_MODE)?'***.***.***.***':htmlspecialchars( $entry["ipaddress"] ) ) ?>" target="_blank"><?php echo(($DEMO_MODE)?'***.***.***.***':htmlspecialchars( $entry["ipaddress"] ) ) ?></a>
<br/>
<?php
}
if(!empty($entry["timestamp"])) 
{
?>
<b>Date:</b> <?php echo htmlspecialchars( strftime($DATE_TIME_FORMAT, (int)$entry["timestamp"]) ) ?>
<br/>&nbsp;<br/>
<?php
}
?>
<?php
}
##########
function show_bans() 
{
$list = ban_list();
if($list !== FALSE) 
{
foreach ($list as $bannedip) 
{
?>
<p>
<input type="checkbox" name="id[]" value="<?php echo htmlspecialchars($bannedip); ?>"/> <?php echo htmlspecialchars($bannedip); ?>
</p>
<?php
}
}
}
##########
function show_bad_words() 
{
$list = bad_word_list();
if($list !== FALSE) 
{
foreach ($list as $bad_word) 
{
?>
<p>
<input type="checkbox" name="id[]" value="<?php echo htmlspecialchars($bad_word); ?>"/> <?php echo htmlspecialchars($bad_word); ?>
</p>
<?php
}
}
}
##########
function show_entries_start_offset() 
{
if(isset($_REQUEST['offset'])) 
{
$offset = $_REQUEST['offset'];
if(!is_numeric($offset) || $offset < 0 || !preg_match('/^[0-9]+$/D', $offset)) die("Error,invalid offset.");
}else{
$offset = 0;
}
$start_offset = intval($offset) + 1;
$count = get_guestbook_entries_count();
if($count < $start_offset) $start_offset = $count;
echo htmlspecialchars($start_offset);
}
##########
function show_entries_end_offset() 
{
global $MAX_ENTRIES_PER_PAGE;
if(isset($_REQUEST['offset'])) 
{
$offset = $_REQUEST['offset'];
if(!is_numeric($offset) || $offset < 0 || !preg_match('/^[0-9]+$/D', $offset)) die("Error,invalid offset.");
}else{
$offset = 0;
}
$end_offset = intval($offset) + $MAX_ENTRIES_PER_PAGE;
$count = get_guestbook_entries_count();
if($count < $end_offset) $end_offset = $count;
echo htmlspecialchars($end_offset);
}
##########
function show_entries($offset = NULL, $maxcount = NULL, $showNavigaion = TRUE, $showCheckboxes = FALSE, $showadminfields = FALSE) 
{
global $MAX_ENTRIES_PER_PAGE;
global $DISPLAY_TIME_ZONE;
if(!empty($DISPLAY_TIME_ZONE))
{
if(function_exists("date_default_timezone_set"))
{
@date_default_timezone_set($DISPLAY_TIME_ZONE);
}else{
putenv("TZ=" . $DISPLAY_TIME_ZONE);
}
}
if(!isset($offset) && isset($_REQUEST['offset'])) 
{
$offset = $_REQUEST['offset'];
if(!is_numeric($offset) || $offset < 0) die("Error,invalid offset.");
}else{
$offset = 0;
}
if(!isset($maxcount)) $maxcount = $MAX_ENTRIES_PER_PAGE;
global $SHOW_PAGE_NUMBER_NAVIGATION;
if($SHOW_PAGE_NUMBER_NAVIGATION === TRUE) 
{
$totalEntries = get_guestbook_entries_count();
}else{
$totalEntries = -1;
}
$guestbookExists = (guestbook_open_for_read() !== FALSE);
$count = 0;
if($guestbookExists) 
{
if($offset > 0) guestbook_forward($offset);
while( $count < $maxcount && ($entry = guestbook_next()) !== FALSE) 
{
$elementId = NULL;
if($count === 0) 
{
$elementId = "firstEntry";
}else if($count === $maxcount - 1)
{
$elementId = "lastEntry";
}
show_entry($entry, $count + $offset, $showCheckboxes, $showadminfields, $elementId);
$count += 1;
}
}
if($showNavigaion) 
{
$showMaxCountInPrevNext = !$SHOW_PAGE_NUMBER_NAVIGATION;
$showPrevious = ($offset > 0);
$showNext = ($guestbookExists && guestbook_next() !== FALSE);
echo("<center>\n");
global $GUESTBOOK_URL_PATH;
if($showPrevious) 
{
global $PREVIOUS_TEXT;
$previous_offset = $offset - $MAX_ENTRIES_PER_PAGE;
if($previous_offset < 0) $previous_offset = 0;
echo("<a href=\"" . urlencode($GUESTBOOK_URL_PATH) . "?offset={$previous_offset}\" id=\"previous\">" . htmlspecialchars($PREVIOUS_TEXT) .
(($showMaxCountInPrevNext)?(" " . htmlspecialchars($maxcount)):"") . "</a>\n");
}
if($SHOW_PAGE_NUMBER_NAVIGATION === TRUE && $totalEntries > $MAX_ENTRIES_PER_PAGE) 
{
global $NAVIGATION_MAX_PAGE_NUMBERS;
echo("<center>");
$pageNumberOffset = $offset - (($NAVIGATION_MAX_PAGE_NUMBERS - 1) * $MAX_ENTRIES_PER_PAGE);
if($pageNumberOffset < 0) $pageNumberOffset = 0;
for($pageNumberCount = 0;
$pageNumberOffset < $totalEntries && $pageNumberCount < $NAVIGATION_MAX_PAGE_NUMBERS;
$pageNumberCount++) 
{
$pageNumberDisplay = ($pageNumberOffset / $MAX_ENTRIES_PER_PAGE) + 1;
if($pageNumberOffset != $offset) 
{
echo("<a href=\"" . urlencode($GUESTBOOK_URL_PATH) . "?offset=" . htmlspecialchars($pageNumberOffset) . "\">" . htmlspecialchars($pageNumberDisplay) . "</a>\n");
}else{
echo("<span id=\"currentPageNumber\">" . htmlspecialchars($pageNumberDisplay) . "</span>\n");
}
$pageNumberOffset += $MAX_ENTRIES_PER_PAGE;
}
echo("</center>");
}else{
if($showPrevious && $showNext) echo " - ";
}
if($showNext) 
{
global $NEXT_TEXT;
$next_offset = $offset + $MAX_ENTRIES_PER_PAGE;
echo("<a href=\"" . urlencode($GUESTBOOK_URL_PATH) . "?offset={$next_offset}\" id=\"next\">" . htmlspecialchars($NEXT_TEXT) .
(($showMaxCountInPrevNext)?(" " . htmlspecialchars($maxcount)):"") . "</a>\n");
}
echo("</center>\n");
}
if($guestbookExists) guestbook_close();
}
##########
function show_guestbook_add_form($formTitle = NULL, $buttonName = NULL) 
{
global $MAX_NAME_LENGTH;
global $MAX_EMAIL_LENGTH;
global $MAX_URL_LENGTH;
global $NAME_FIELD_NAME;
global $EMAIL_FIELD_NAME;
global $URL_FIELD_NAME;
global $COMMENTS_FIELD_NAME;
global $ADD_FORM_LEGEND;
global $ADD_FORM_BUTTON_TEXT;
global $CHALLENGE_STRING_LENGTH;
global $CHALLENGE_FIELD_NAME;
global $CHALLENGE_FIELD_PARAM_NAME;
global $ENABLE_EMAIL_FIELD;
global $ENABLE_URL_FIELD;
global $ENABLE_COMMENT_FIELD;
global $GUESTBOOK_URL_PATH;
if(!isset($formTitle)) $formTitle = $ADD_FORM_LEGEND;
if(!isset($buttonName)) $buttonName = $ADD_FORM_BUTTON_TEXT;
$ipaddress = $_SERVER['REMOTE_ADDR'];
if(is_banned($ipaddress)) return FALSE;
$nameValue = "";
if(isset($_POST['name'])) $nameValue = "value=\"" . htmlspecialchars($_POST['name']) . "\" ";
$emailValue = "";
if(isset($_POST['email'])) $emailValue = "value=\"" . htmlspecialchars($_POST['email']) . "\" ";
$urlValue = "";
if(isset($_POST['url'])) $urlValue = "value=\"" . htmlspecialchars($_POST['url']) . "\" ";
$commentsValue = "";
if(isset($_POST['comments'])) $commentsValue = htmlspecialchars($_POST['comments']);
?>
<center>
<form method="post" action="<?php echo urlencode($GUESTBOOK_URL_PATH); ?>">
<?php echo htmlspecialchars($formTitle); ?>
<?php show_errors(); ?>
<?php echo htmlspecialchars($NAME_FIELD_NAME) ?>:
<br/>
<input type="text" name="name" id="name" maxlength="<?php echo htmlspecialchars($MAX_NAME_LENGTH); ?>" <?php echo $nameValue; ?>/>
<br/>
<br/>
<?php if($ENABLE_EMAIL_FIELD === TRUE) 
{ 
?>
<?php echo htmlspecialchars($EMAIL_FIELD_NAME) ?>:
<br/>
<input type="text" name="email" id="email" maxlength="<?php echo htmlspecialchars($MAX_EMAIL_LENGTH); ?>" <?php echo $emailValue; ?>/>
<br/>
<br/>
<?php 
} 
?>
<?php if($ENABLE_URL_FIELD === TRUE) 
{ 
?>
<?php echo htmlspecialchars($URL_FIELD_NAME) ?>:
<br/>
<input type="text" name="url" id="url" maxlength="<?php echo htmlspecialchars($MAX_URL_LENGTH); ?>" <?php echo $urlValue; ?>/>
<br/>
<br/>
<?php 
}
?>
<?php if($ENABLE_COMMENT_FIELD === TRUE) 
{ 
?>
<?php echo htmlspecialchars($COMMENTS_FIELD_NAME) ?>:
<br/>
<textarea name="comments" id="comments" cols="30" rows="5"><?php echo $commentsValue; ?></textarea>
<br/>
<br/>
<?php 
}
?>
<?php
global $CHALLENGE_ENABLED;
if($CHALLENGE_ENABLED === TRUE) 
{
createChallengeString();
?>
<img src="<?php echo urlencode($GUESTBOOK_URL_PATH); ?>?action=challengeimage" alt="Captcha"/>
<input type="text" name="<?php echo htmlspecialchars($CHALLENGE_FIELD_PARAM_NAME); ?>" id="<?php echo htmlspecialchars($CHALLENGE_FIELD_PARAM_NAME); ?>" maxlength="<?php echo htmlspecialchars($CHALLENGE_STRING_LENGTH); ?>" size="<?php echo htmlspecialchars($CHALLENGE_STRING_LENGTH); ?>"/>
<?php
}
?>
<input type="hidden" name="action" value="add"/>
<input type="submit" value="<?php echo htmlspecialchars($buttonName); ?>"/>
</form>
</center>
<?php
}
##########
function show_errors() 
{
global $dbs_error;
if(!empty($dbs_error)) 
{
echo("<center>\n");
echo("<font color=\"red\">\n");
echo("" . $dbs_error . "\n");
echo("</font>");
echo("</center>\n");
}
}
##########
function show_added_entry() 
{
show_entries(0, 1, FALSE);
}
##########
function show_entries_page() 
{
global $CHALLENGE_ENABLED;
if($CHALLENGE_ENABLED === TRUE) 
{ 
@session_start(); 
}
include_from_template('entries.php');
}
##########
function show_entry_count() 
{
echo htmlspecialchars(get_guestbook_entries_count());
}
?>